/*
 * License: The code is released under Creative Commons Attribution 2.5 License
 * (http://creativecommons.org/licenses/by/2.5/)
 */

package javaballsopt;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Graphics;
import java.io.IOException;
import java.net.URL;

import javax.imageio.ImageIO;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 *
 * @author rbair
 */
public class JavaBallsApplet extends JFrame { // JApplet {

	static public void main(String[] args)
	{
		JavaBallsApplet lJavaBallsApplet = new JavaBallsApplet();
		lJavaBallsApplet.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		lJavaBallsApplet.setSize(500, 300);
		lJavaBallsApplet.setVisible(true);
		lJavaBallsApplet.init();
	}
	
    public JavaBallsApplet() {
    }

    private JLabel fps = new JLabel("-- fps");
    private JXImage ball;
    private BallsTest javaTest;
    
    //@Override 
    public void init() {
        try {
            setLayout(new BorderLayout());
            JPanel pane = new JPanel(null);
            pane.setBackground(Color.WHITE);
            add(pane);
            
            fps.setSize(400, 20);
            fps.setLocation(10, 10);
            pane.add(fps);
            URL url = javaballsopt.JavaBallsApplet.class.getResource("resources/ball.png");
            ball = new JXImage(GraphicsUtilities.toCompatibleImage(ImageIO.read(url)));
            pane.add(ball);
            javaTest = new BallsTest(ball, ballcnt);
            javaTest._showFPS = new BallsTest.ShowFpsCallback() {
                public void setFps(double fps_value) {
                    fps.setText(fps_value + " fps");
                    measurementTest++;
					System.out.println(javaTest._ballsO.size() + " balls " + fps_value + " fps");
					if (measurementTest == 2)                     
					{
						System.err.println(javaTest._ballsO.size() + ";" + (int)fps_value + ";");
						measurementTest = 0;
						
						stopAnimation();
						ballcnt += 100;
						startAnimationN(ballcnt);
						
						if (javaTest._ballsO.size() > 5000) System.exit(0);
					}
                }
            };
            javaTest.start();
        } catch (IOException ex) {
            System.out.println("Dang. Failed to read the ball image");
        }
    }
	int measurementTest = 0;
	int ballcnt = 100;
    
    public void startAnimation() {
        javaTest.start();
    }
    
    public void startAnimationN(int N) {
    	Graphics g = getGraphics();
    	g.setColor(Color.white);
    	g.fillRect(0, 0, getWidth(), getHeight());
    	g.dispose();
        javaTest.startN(N);
    }
    
    public void stopAnimation() {
        javaTest.stop();
        fps.setText("-- fps");
    }
}
